<?php 
/********************************************
*     Amazon AWS Manager Addon For WHMCS    *
*********************************************/

/* Copyright (c) Metclouds Technologies Pvt Ltd 2009 - 2016 */
/* See the file NOTICE for conditions of use and distribution. */
?>
<style type="text/css">
#contentarea h1
{
	color:white !important;
	padding: 8px;
        background:#0065A0 !important;	
}
</style>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
<script>
$(document).ready(function(){
    $(".close_msg").click(function(){
        $(".err_msg").hide();
    });
});
</script>

<?php 

date_default_timezone_set("UTC");

require 'vendor/autoload.php';
require 'regions.php';

require 'vendor/aws/aws-sdk-php/src/Ec2/Ec2Client.php';
use Aws\Common\Aws;
use Aws\Common\Enum\Region;
use Aws\EC2\Ec2Client;


$visitedregions = $availableregions = array();

$cityRegions = array('us-east-1'=>'US East (N. Virginia)','us-east-2'=>'US East (Ohio)',
	'us-west-2'=>'US West (Oregon)','ap-northeast-2'=>'Asia Pacific (Seoul)',
	'ap-southeast-1'=>'Asia Pacific (Singapore)','ap-southeast-2'=>'Asia Pacific (Sydney)',
	'ap-northeast-1'=>'Asia Pacific (Tokyo)','eu-central-1'=>'EU (Frankfurt)',
	'eu-west-1'=>'EU (Ireland)','ap-south-1'=>'Asia Pacific (Mumbai)',
	'sa-east-1'=>'South America (São Paulo)','us-west-1'=>'US West (N. California)');

$cityRegions = array('us-east-1'=>'N. Virginia','us-east-2'=>'Ohio',
        'us-west-2'=>'Oregon','ap-northeast-2'=>'Seoul',
        'ap-southeast-1'=>'Singapore','ap-southeast-2'=>'Sydney',
        'ap-northeast-1'=>'Tokyo','eu-central-1'=>'Frankfurt',
        'eu-west-1'=>'Ireland','ap-south-1'=>'Mumbai',
        'sa-east-1'=>'Sao Paulo','us-west-1'=>'N. California','ca-central-1'=>'Canada','eu-west-2'=>'London');

try
{
	$client = Ec2Client::factory(array(
        'region' => 'us-east-1',
        'version'=> '2016-04-01',
 	'credentials' => array(
          'key'       => "$key",
         'secret'    => "$secret"
  ),
));
}

catch(Exception $e) 
{
	echo $e->getMessage();
}

if(isset($_SESSION['aws_msg']))
{
	echo "<h1 style='background:#D11A24 !important' class='err_msg'>".$_SESSION['aws_msg']."<div style='cursor: pointer;float:right;font-size: 14px;padding: 4px;' class='close_msg'>close</div></h1>";
	unset($_SESSION['aws_msg']);
}

$availableregions = $client->DescribeRegions();
   
     
foreach( $regions['Regions'] as $region)
{
	
		try
		{
			$regionName = $region['RegionName'];
			$visitedregions[] = $region['RegionName'];
			$client = Ec2Client::factory(array(
    'region' 	=> $region['RegionName'],
    'version'	=> '2016-04-01',
 	'credentials' => array(
    'key'       => "$key",
    'secret'    => "$secret"
  )
));

			$instances = $client->DescribeInstances();
			
			$reservations = $instances['Reservations'];
			$countReservation = count($reservations);
	?>		
			<div class="region" style="padding: 6px 6px 6px 13px;background:#5781A0;font-weight:bold;color: white;">
		
			Region: <?php echo $cityRegions[$region['RegionName']]." ( ".$region['RegionName']." )";?></div>
			<?php 
					
			if($countReservation)
			{
				foreach ($reservations as $reservation) 
				{
					$instances = $reservation['Instances'];
					foreach ($instances as $instance) 
					{
						$instanceName = '';
						foreach ($instance['Tags'] as $tag) 
						{
							if ($tag['Key'] == 'Name') 
							{
								$instanceName = $tag['Value'];
							}
						}
				?>
			

	<div class="instance" style="border: 1px solid #678CA8;margin-bottom: 15px;margin-top: 5px;">
				<div style="width: 50%;display: inline-block;margin-bottom: 8px;">
<div class="head" style="padding: 6px 6px 6px 13px;">Name: <?php echo $instanceName?></div>
<div class="head" style="padding: 6px 6px 6px 13px;">State: <?php echo ucfirst($instance['State']['Name'])?></div>
<div class="head" style="padding: 6px 6px 6px 13px; width: 50%;">Instance ID: <?php echo $instance['InstanceId']?></div>
</div>

<div style="display: inline-block;float:right;width: 234px;margin: 10px">
<?php 
if(ucfirst($instance['State']['Name']) == 'Running')
				{?>
<a style="color: white;
    padding: 5px;
    text-decoration: none;font-weight:bold" href="addonmodules.php?module=amazon_aws_manager&action=stop&id=<?php echo $instance['InstanceId']?>&region=<?php echo $regionName?>" onclick="return confirm('Are you sure to shut down?')">
<div class="head" style="padding: 10px 10px 10px 13px;text-align: center;
    width: 120px;background: #5781A0;float: right;margin-bottom: 5px;">
Stop
				</div>
</a>
				<?php }
				elseif(ucfirst($instance['State']['Name']) == 'Stopped')
				{?>
<a style="color: white;
    padding: 5px;
    text-decoration: none;font-weight:bold" href="addonmodules.php?module=amazon_aws_manager&action=start&id=<?php echo $instance['InstanceId']?>&region=<?php echo $regionName?>" onclick="return confirm('Are you sure to shut down?')">
				<div class="head" style="padding: 10px 10px 10px 13px;text-align: center;
    width: 120px;background: #5781A0;float: right;">
Start
				</div>
</a>
<?php 
					}
if(ucfirst($instance['State']['Name']) != 'Terminated')
                                {?>
<a style="color: white;
    padding: 5px;
    text-decoration: none;font-weight:bold" href="addonmodules.php?module=amazon_aws_manager&action=terminate&id=<?php echo $instance['InstanceId']?>&region=<?php echo $regionName?>" onclick="return confirm('Are you sure to terminate?')">

                                <div class="head" style="padding: 10px 10px 10px 13px;text-align: center;
    width: 120px;background: #5781A0;float: right;">
Terminate
                                </div>
</a>
<?php
                                        }?>

</div>
			</div>
			
				<?php 
					
					}
				}
			}
			else
			{?>
				<div class="instance" style="border: 1px solid #678CA8;margin-bottom: 15px;margin-top: 5px;"><div class="head" style="padding: 6px 6px 6px 13px;">No instances</div>
			
	</div>
			<?php 
			}
		}
	catch(Exception $e) 
		{
  			echo $e->getMessage();
		}
}


foreach( $availableregions['Regions'] as $availableregion)
{
	
	if(in_array($availableregion['RegionName'],$visitedregions))
	{
		continue;
	}
	else
	{
		try
		{
			
			$client = Ec2Client::factory(array(
    'region' 	=> $availableregion['RegionName'],
    'version'	=> '2016-04-01',
 	'credentials' => array(
    'key'       => "$key",
    'secret'    => "$secret"
  )
));

			$instances = $client->DescribeInstances();
			
			$reservations = $instances['Reservations'];
			$countReservation = count($reservations);
	?>		
			<div class="region" style="padding: 6px 6px 6px 13px;background:#5781A0;color: white;">
		
			Region: <?php echo $cityRegions[$availableregion['RegionName']]." ( ".$availableregion['RegionName']." )";?></div>
			<?php 
					
			if($countReservation)
			{
				foreach ($reservations as $reservation) 
				{
					$instances = $reservation['Instances'];
					foreach ($instances as $instance) 
					{
						$instanceName = '';
						foreach ($instance['Tags'] as $tag) 
						{
							if ($tag['Key'] == 'Name') 
							{
								$instanceName = $tag['Value'];
							}
						}
				?>
			
<div class="instance" style="border: 1px solid #678CA8;margin-bottom: 15px;margin-top: 5px;">
				<div style="width: 50%;display: inline-block;margin-bottom: 8px;">
<div class="head" style="padding: 6px 6px 6px 13px;">Name: <?php echo $instanceName?></div>
<div class="head" style="padding: 6px 6px 6px 13px;">State: <?php echo ucfirst($instance['State']['Name'])?></div>
<div class="head" style="padding: 6px 6px 6px 13px; width: 50%;">Instance ID: <?php echo $instance['InstanceId']?></div>
</div>

<div style="display: inline-block;float:right;width: 234px;margin: 10px">
<?php 
if(ucfirst($instance['State']['Name']) == 'Running')
				{?>
<a style="color: white;
    padding: 5px;
    text-decoration: none;font-weight:bold" href="addonmodules.php?module=amazon_aws_manager&action=stop&id=<?php echo $instance['InstanceId']?>&region=<?php echo $regionName?>" onclick="return confirm('Are you sure to shut down?')">
<div class="head" style="padding: 10px 10px 10px 13px;text-align: center;
    width: 120px;background: #5781A0;float: right;margin-bottom: 5px;">
Stop
				</div>
</a>
				<?php }
				elseif(ucfirst($instance['State']['Name']) == 'Stopped')
				{?>
<a style="color: white;
    padding: 5px;
    text-decoration: none;font-weight:bold" href="addonmodules.php?module=amazon_aws_manager&action=start&id=<?php echo $instance['InstanceId']?>&region=<?php echo $regionName?>" onclick="return confirm('Are you sure to shut down?')">
				<div class="head" style="padding: 10px 10px 10px 13px;text-align: center;
    width: 120px;background: #5781A0;float: right;">
Start
				</div>
</a>
<?php 
					}
if(ucfirst($instance['State']['Name']) != 'Terminated')
                                {?>
<a style="color: white;
    padding: 5px;
    text-decoration: none;font-weight:bold" href="addonmodules.php?module=amazon_aws_manager&action=terminate&id=<?php echo $instance['InstanceId']?>&region=<?php echo $regionName?>" onclick="return confirm('Are you sure to terminate?')">

                                <div class="head" style="padding: 10px 10px 10px 13px;text-align: center;
    width: 120px;background: #5781A0;float: right;">
Terminate
                                </div>
</a>
<?php
                                        }?>

</div>
			</div>			
				<?php 
					
					}
				}
			}
			else
			{?>
				<div class="instance" style="border: 1px solid #678CA8;margin-bottom: 15px;margin-top: 5px;"><div class="head" style="padding: 6px 6px 6px 13px;">No instances</div>
			
	</div>
			<?php 
			}
		}
	catch(Exception $e) 
		{
  			echo $e->getMessage();
		}
	}
}


